/*
* Copyright (c) 2012-2016, NVIDIA CORPORATION. All rights reserved.
*
* NVIDIA CORPORATION and its licensors retain all intellectual property
* and proprietary rights in and to this software, related documentation
* and any modifications thereto. Any use, reproduction, disclosure or
* distribution of this software and related documentation without an express
* license agreement from NVIDIA CORPORATION is strictly prohibited.
*/
#pragma once

#include <nvrhi/nvrhi.h>
#include <vector>
#include <string>

namespace nvrhi {

static const char* g_BlobSignature = "NVSP";
static size_t g_BlobSignatureSize = 4;

struct ShaderBlobEntry
{
	uint32_t hashKeySize;
	uint32_t dataSize;
	uint32_t dataCrc;
	uint32_t defineHash;
	uint32_t flags;
};

bool FindPermutationInBlob(const void* blob, size_t blobSize, const ShaderConstant* constants, uint32_t numConstants, const void** pBinary, size_t* pSize);
void EnumeratePermutationsInBlob(const void* blob, size_t blobSize, std::vector<std::string>& permutations);
std::string FormatShaderNotFoundMessage(const void* blob, size_t blobSize, const ShaderConstant* constants, uint32_t numConstants);

} // namespace nvrhi
