/*
* Copyright (c) 2012-2016, NVIDIA CORPORATION. All rights reserved.
*
* NVIDIA CORPORATION and its licensors retain all intellectual property
* and proprietary rights in and to this software, related documentation
* and any modifications thereto. Any use, reproduction, disclosure or
* distribution of this software and related documentation without an express
* license agreement from NVIDIA CORPORATION is strictly prohibited.
*/
#pragma once

#include <nvrhi/nvrhi.h>

namespace nvrhi
{
    namespace utils
    {
        BlendState CreateAddBlendState(
            BlendState::BlendValue srcBlend,
            BlendState::BlendValue dstBlend);


        BufferDesc CreateConstantBufferDesc(
            const uint32_t byteSize,
            const char* const debugName,
            const bool isVolatile = true);

        bool CreateBindingSetAndLayout(
            IDevice* device, 
            const BindingSetDesc& bindingSetDesc, 
            BindingLayoutHandle& bindingLayout, 
            BindingSetHandle& bindingSet);

        void ClearColorAttachment(
            ICommandList* commandList,
            IFramebuffer* framebuffer,
            uint32_t attachmentIndex,
            Color color
        );

        void ClearDepthStencilAttachment(
            ICommandList* commandList,
            IFramebuffer* framebuffer,
            float depth,
            uint32_t stencil
        );

        const char* GraphicsAPIToString(GraphicsAPI api);
    }
}
