/*
* Copyright (c) 2012-2016, NVIDIA CORPORATION. All rights reserved.
*
* NVIDIA CORPORATION and its licensors retain all intellectual property
* and proprietary rights in and to this software, related documentation
* and any modifications thereto. Any use, reproduction, disclosure or
* distribution of this software and related documentation without an express
* license agreement from NVIDIA CORPORATION is strictly prohibited.
*/
#pragma once

namespace nvrhi 
{
namespace vulkan 
{

class VulkanAllocator
{
public:
    VulkanAllocator(VulkanContext& context)
        : context(context)
    { }

    vk::Result allocateBufferMemory(Buffer *buffer);
    void freeBufferMemory(Buffer *buffer);

    vk::Result allocateTextureMemory(Texture *texture);
    void freeTextureMemory(Texture *texture);

private:
    vk::Result allocateMemory(MemoryResource *res,
                              vk::MemoryRequirements memRequirements,
                              vk::MemoryPropertyFlags memProperties);
    void freeMemory(MemoryResource *res);

    VulkanContext& context;
};

} // namespace vulkan
} // namespace nvrhi
